<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task48.50</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome Icons -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- IonIcons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>
<!--
`body` tag options:

  Apply one or more of the following classes to to the body tag
  to get the desired effect

  * sidebar-collapse
  * sidebar-mini
-->

<body class="hold-transition sidebar-mini">
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Cuong Trinh</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Cuong Trinh</a>
          </div>
        </div>
        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="./index.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v1</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="./index2.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="./index3.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v3</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Filter Data Role - User Table</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Filter Data Role</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <div class="content">
        <div class="container">
          <div class="text-center mt-4 mb-3">
            <h2>F100 - QUẢN TRỊ NGƯỜI DÙNG</h2>
          </div>
          <div class="jumbotron container">
            <div class="row form-group mb-0">
              <div class="col-sm-3">
                <label for="voucherCodeInput">Role</label>
              </div>
              <div class="col-sm-6">
                <select id="roleSelect" class="form-control"></select>
              </div>
              <div class="col-sm-3">
                <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
              </div>
            </div>
          </div>
          <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead class="thead-dark">
              <tr>
                <th scope='col'>STT</th>
                <th scope='col'>Username</th>
                <th scope='col'>First name</th>
                <th scope='col'>Last name</th>
                <th scope='col'>Email</th>
                <th scope='col'>Age</th>
                <th scope='col'>Role</th>
                <th scope='col'>Action</th>
              </tr>
            </thead>
            <tbody>
            </tbody>
          </table>
        </div>
      </div>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <!-- Main Footer -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">Cuongtrinh.io</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 3.2.0
      </div>
    </footer>
  </div>
  <!-- ./wrapper -->
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Mảng gUserObjects là mảng chứa dữ liệu users
    var gUserObjects = [
      {
        id: 2,
        username: "quannv",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        roleId: 5
      },
      {
        id: 3,
        username: "longdh",
        firstname: "Do Hoang",
        lastname: "Long",
        age: 19,
        email: "long@gmail.com",
        roleId: 8
      },
      {
        id: 4,
        username: "hiendt",
        firstname: "Do Thi",
        lastname: "Hien",
        age: 29,
        email: "hien@gmail.com",
        roleId: 11
      },
      {
        id: 6,
        username: "lanht",
        firstname: "Ho Thi",
        lastname: "Lan",
        age: 27,
        email: "lan@gmail.com",
        roleId: 13
      }
    ];
    // Mảng gRoleObjects là mảng chứa dữ liệu các roles
    var gRoleObjects = [
      {
        roleId: 5,
        roleName: "Admin"
      },
      {
        roleId: 8,
        roleName: "Manager"
      },
      {
        roleId: 11,
        roleName: "Teacher"
      },
      {
        roleId: 13,
        roleName: "Staff"
      }
    ];

    var gNameCol = [
      "stt",
      "username",
      "firstname",
      "lastname",
      "email",
      "age",
      "roleId",
      "action"
    ];
    const gSTT_COL = 0;
    const gUSER_NAME_COL = 1;
    const gFIRST_NAME_COL = 2;
    const gLAST_NAME_COL = 3;
    const gEMAIL_COL = 4;
    const gAGE_COL = 5;
    const gROLE_COL = 6;
    const gACTION_COL = 7;


    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
    });

    //gán sự kiện cho nút Filter Role
    $("#btn-filter-role").on("click", function () {
      onBtnFilterRoleClick();
    })

    //gán sự kiện cho nút Dice History
    $("#dice-history").on("click", function () {
      onBtnDiceHistoryClick();
    })

    //gán sự kiện cho nút Voucher History
    $("#voucher-history").on("click", function () {
      onBtnVoucherHistoryClick();
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện filter order
    function onBtnFilterRoleClick() {
      //khai báo đối tượng chứa dữ liệu filter
      var vFilterRoleId = {
        roleId: -1
      };
      //B1: thu thap du lieu de filter
      getFilterFormData(vFilterRoleId);
      //B2: validate data
      //B3: xu ly filter
      filterRoles(vFilterRoleId);
    }
    //hàm xử lý khi load trang
    function onPageLoading() {
      loadDataToRoleSelect();
      showTableUserDataTable();
      $('[data-toggle="tooltip"]').tooltip();
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function onBtnVoucherHistoryClick(paramDataRow) {
      //xử lý chuyển trang sang Trang voucherHistory.html
      const vDETAIL_FORM_URL = "voucherHistory.html"
      var vUrlSiteToOpen = vDETAIL_FORM_URL +
        "?user_name=" + paramDataRow.username +
        "&first_name=" + paramDataRow.firstname +
        "&last_name=" + paramDataRow.lastname;
      location.href = vUrlSiteToOpen;
    }

    function onBtnDiceHistoryClick(paramDataRow) {
      //xử lý chuyển trang sang Trang diceHistory.html
      const vDETAIL_FORM_URL = "diceHistory.html"
      var vUrlSiteToOpen = vDETAIL_FORM_URL +
        "?user_name=" + paramDataRow.username +
        "&first_name=" + paramDataRow.firstname +
        "&last_name=" + paramDataRow.lastname;
      location.href = vUrlSiteToOpen;
    }
    //hàm thực hiện lọc và hiển thị lên table
    function filterRoles(paramFilterFormObj) {
      var vRoleResult = [];
      //thực hiện việc lọc
      //debugger
      vRoleResult = gUserObjects.filter(function (paramOrder) {
        return (paramFilterFormObj.roleId === 0 || paramOrder.roleId === paramFilterFormObj.roleId);
      });
      console.log(vRoleResult);
      //load dữ liệu sau khi filter trả về table
      loadRolesToTable(vRoleResult);
    }

    //hàm thu thập dữ liệu để lọc
    function getFilterFormData(paramFilterFormObj) {
      paramFilterFormObj.roleId = parseInt($("#roleSelect").val(), 10);
      console.log("paramFilterFormObj.roleId: " + paramFilterFormObj.roleId);
    }

    //hàm load dữ liệu vào order table
    function loadRolesToTable(paramOrderArray) {
      $("#user-table").DataTable().clear();
      $("#user-table").DataTable().rows.add(paramOrderArray);
      $("#user-table").DataTable().draw();
    }




    function mappingRoleNameByID(paramData, paramType, paramRow) {
      for (let bI = 0; bI < gRoleObjects.length; bI++) {
        const bRoleObjItem = gRoleObjects[bI];
        if (paramData == bRoleObjItem.roleId) {
          return bRoleObjItem.roleName;
        }
      }
    }

    function loadDataToRoleSelect() {
      var vRoleSelect = $("#roleSelect");
      $("<option/>", {
        text: "--- Chọn tất cả ---",
        value: 0
      }).appendTo(vRoleSelect);

      for (let bI = 0; bI < gRoleObjects.length; bI++) {
        var bPizzaTypeOption = $("<option/>", {
          text: gRoleObjects[bI].roleName,
          value: gRoleObjects[bI].roleId
        }).appendTo(vRoleSelect);
      }
    }
    function showTableUserDataTable() {
      console.log(gUserObjects);
      $("#user-table").DataTable({
        data: gUserObjects,
        columns: [
          { data: gNameCol[gSTT_COL] },
          { data: gNameCol[gUSER_NAME_COL] },
          { data: gNameCol[gFIRST_NAME_COL] },
          { data: gNameCol[gLAST_NAME_COL] },
          { data: gNameCol[gEMAIL_COL] },
          { data: gNameCol[gAGE_COL] },
          { data: gNameCol[gROLE_COL] },
          { data: gNameCol[gACTION_COL] }
        ], // Các thuộc tính của USER sẽ  match với từng column
        columnDefs: [
          //định nghĩa các cột cần hiện ra
          {
            targets: gSTT_COL, //cột STT
            className: "text-center text-primary",
            render: function (data, type, row, meta) {
              return meta.row + meta.settings._iDisplayStart + 1;
            }
          },
          {
            targets: gROLE_COL,
            className: "text-right",
            render: mappingRoleNameByID
          },
          {
            targets: gACTION_COL, //cột Action
            className: "text-center",
            defaultContent: `
            <button id="dice-history" class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
            <button id="voucher-history" class="btn btn-link btn-sm" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>`
          }
        ]
      });
    }

  </script>
  <!-- REQUIRED SCRIPTS -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- AdminLTE -->
  <script src="dist/js/adminlte.js"></script>

</body>

</html>